## xca 2.5.0

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.16.0)

project(xca
	DESCRIPTION "X Certificate and Key management"
	HOMEPAGE_URL http://xca.hohnstaedt.de
	LANGUAGES CXX
)

file(READ VERSION.txt ver)
string(REGEX MATCH "([0-9\.]*)" _ ${ver})
set(PROJECT_VERSION ${CMAKE_MATCH_1})

cmake_host_system_information(RESULT OS_DATA_LIST QUERY
	OS_NAME OS_RELEASE OS_VERSION OS_PLATFORM)
list(JOIN OS_DATA_LIST " -- " OS_DATA)
message(STATUS ${OS_DATA})

include(GNUInstallDirs)

##### Git command to tweak the version and commit hash
include(cmake/git_version.cmake)

##### Build specifications

set(ADDRESS_SANITIZER OFF CACHE BOOL "Enable Address sanitizing")
set(CMAKE_POSITION_INDEPENDENT_CODE ON)

set(CMAKE_CXX_STANDARD 17)
set(CMAKE_CXX_STANDARD_REQUIRED ON)

set(CMAKE_AUTOMOC ON)
set(CMAKE_AUTORCC ON)
set(CMAKE_AUTOUIC_SEARCH_PATHS "${PROJECT_SOURCE_DIR}/ui")
set(CMAKE_AUTOUIC ON)
add_compile_definitions(OPENSSL_SUPPRESS_DEPRECATED QT_MESSAGELOGCONTEXT)

if (ADDRESS_SANITIZER)
  add_compile_options(-fsanitize=address -O1 -fno-omit-frame-pointer -g)
  set(ASAN_LIB -fsanitize=address)
endif()

file(GLOB UI_FILES ${CMAKE_AUTOUIC_SEARCH_PATHS}/*.ui)

configure_file(local.h.in local.h)

##### Libraries and executables
add_executable(${CMAKE_PROJECT_NAME} img/imgres.qrc ${UI_FILES} ${PROJECT_BINARY_DIR}/local.h)
add_executable(xcadoc ${PROJECT_BINARY_DIR}/local.h)

include_directories(${PROJECT_BINARY_DIR} ${PROJECT_SOURCE_DIR})

if (APPLE)
  execute_process(COMMAND brew --prefix OUTPUT_STRIP_TRAILING_WHITESPACE
                  OUTPUT_VARIABLE BREW_PREFIX ERROR_QUIET)
  # Preset the default brew paths....
  if (NOT CMAKE_PREFIX_PATH)
    set(CMAKE_PREFIX_PATH ${BREW_PREFIX}/opt/qt@6/ ${BREW_PREFIX}/opt/openssl@3)
  endif()
elseif(WIN32)
  if (NOT CMAKE_PREFIX_PATH)
    set(CMAKE_PREFIX_PATH $ENV{UserProfile} $ENV{PROGRAMFILES}/OpenSSL-Win64)
  endif()
  if (NOT OPENSSL_LIBRARY_MAJOR)
    set(OPENSSL_LIBRARY_MAJOR 3) # For OpenSSL 1.1.1 use "1_1"
  endif()
  file(TO_CMAKE_PATH $ENV{WINDIR}/system32 SYSTEM32)
endif()

set(QTFIXEDVERSION Qt6 Qt5 CACHE STRING "Force q specific QT version 'Qt5' or 'Qt6'")
find_package(OpenSSL REQUIRED)
find_package(QT NAMES ${QTFIXEDVERSION} REQUIRED COMPONENTS Core)
set(QT Qt${QT_VERSION_MAJOR})
find_package(${QT} REQUIRED COMPONENTS Core Widgets Sql Help LinguistTools)
message(STATUS "Using ${QT} with version ${QT_VERSION}")

get_target_property(qmake_executable ${QT}::qmake IMPORTED_LOCATION)
get_filename_component(_qt_bin_dir "${qmake_executable}" DIRECTORY)

if (NOT OPENSSL_ROOT_DIR)
  get_filename_component(OPENSSL_ROOT_DIR ${OPENSSL_INCLUDE_DIR} DIRECTORY)
endif()

target_link_libraries(${CMAKE_PROJECT_NAME}
	OpenSSL::Crypto
	${QT}::Widgets ${QT}::Core ${QT}::Sql ${QT}::Help
	${ASAN_LIB}
)
target_link_libraries(xcadoc
	OpenSSL::Crypto
	${QT}::Widgets ${QT}::Core ${QT}::Sql ${QT}::Help
	${ASAN_LIB}
)

if (APPLE)

  find_library(IOKIT_LIBRARY IOKit)
  find_library(COREFOUNDATION_LIBRARY CoreFoundation)
  target_link_libraries(${CMAKE_PROJECT_NAME}
	${IOKIT_LIBRARY} ${COREFOUNDATION_LIBRARY}
  )
  set(CMAKE_MACOSX_BUNDLE ON)

  # Avoid bin/ sub-directory in DMG
  set(RUNTIME_DEST .)
  set(CMAKE_CXX_VISIBILITY_PRESET hidden)

elseif(WIN32)

  set(RUNTIME_DEST ${CMAKE_PROJECT_NAME}-portable-${PROJECT_VERSION})

else()

  set(RUNTIME_DEST ${CMAKE_INSTALL_BINDIR})

endif()

macro(guid content)
  string(
    UUID GUID NAMESPACE f243d4ea-d51d-42fc-a3c0-4eb186c55d34
    NAME ${content} TYPE SHA1
  )
endmacro()

macro(WixFile filename content)
  file(WRITE ${filename} "<?xml version=\"1.0\" encoding=\"UTF-8\"?>\n"
    "<Wix xmlns=\"http://schemas.microsoft.com/wix/2006/wi\">\n<Fragment>\n"
    ${content}
    "\n</Fragment>\n</Wix>")
endmacro()

##### Sub directories

add_subdirectory(lib)
add_subdirectory(widgets)

include(misc/CMakeLists.txt)
include(lang/CMakeLists.txt)
include(doc/CMakeLists.txt)
include(img/CMakeLists.txt)

install(TARGETS ${CMAKE_PROJECT_NAME}
	RESOURCE DESTINATION Resources
	BUNDLE DESTINATION .
	RUNTIME DESTINATION ${RUNTIME_DEST}
)

set(CPACK_PACKAGE_VERSION "${PROJECT_VERSION}")

###############################################
##### Host specific settings

if(APPLE)
  set_target_properties(${CMAKE_PROJECT_NAME} PROPERTIES
	MACOSX_BUNDLE TRUE
	XCODE_ATTRIBUTE_INSTALL_PATH /Applications
	XCODE_ATTRIBUTE_SKIP_INSTALL No
	RESOURCE "${APP_RESOURCES}"
  )
  find_program(MACDEPLOYQT_EXECUTABLE macdeployqt HINTS ${_qt_bin_dir})
  add_custom_command(TARGET ${PROJECT_NAME} POST_BUILD
    COMMAND ${MACDEPLOYQT_EXECUTABLE} $<TARGET_FILE_DIR:${PROJECT_NAME}>/../..
        -always-overwrite
    COMMENT "Running macdeployqt..."
  )
  if (DEFINED ENV{APPLE_DEVELOPER_HASH})
    add_custom_command(TARGET ${PROJECT_NAME} POST_BUILD
      COMMAND codesign --deep --signature-size=96000 --options=runtime --timestamp
		--entitlements ${PROJECT_SOURCE_DIR}/misc/entitlement.plist
                --force -s "$ENV{APPLE_DEVELOPER_HASH}"
		$<TARGET_FILE_DIR:${PROJECT_NAME}>/../..
      COMMENT "Running codesign for $ENV{APPLE_DEVELOPER} ..."
    )
  endif()

  set(CPACK_BUNDLE_NAME ${PROJECT_NAME})
  set(CPACK_GENERATOR "DragNDrop") #;productbuild")

elseif(WIN32)
  find_program(WINDEPLOYQT_EXECUTABLE windeployqt HINTS ${_qt_bin_dir})
  add_custom_command(TARGET ${CMAKE_PROJECT_NAME} POST_BUILD
    COMMAND ${WINDEPLOYQT_EXECUTABLE} $<TARGET_FILE:${PROJECT_NAME}>
        --dir ${CMAKE_BINARY_DIR} --compiler-runtime --no-translations
    COMMENT "Running windeployqt on ${CMAKE_PROJECT_NAME} ..."
  )
  add_custom_command(TARGET xcadoc POST_BUILD
    COMMAND ${WINDEPLOYQT_EXECUTABLE} $<TARGET_FILE:xcadoc>
        --dir ${CMAKE_BINARY_DIR} --no-translations
    COMMENT "Running windeployqt on xcadoc ..."
  )
  set(QT_USE_QTMAIN TRUE)
  set(CPACK_GENERATOR WIX)
  set(CPACK_PACKAGE_VENDOR "Christian Hohnstädt")
  set(CPACK_WIX_TEMPLATE "${PROJECT_SOURCE_DIR}/misc/xca.wxs")
  set(CPACK_WIX_UPGRADE_GUID "23fdacfe-3ef8-45b4-81e8-b0c90244c217")
  set(CPACK_WIX_UI_BANNER "${PROJECT_SOURCE_DIR}/img/banner.bmp")
  set(CPACK_WIX_UI_DIALOG "${PROJECT_SOURCE_DIR}/img/dialog.bmp")
  set(CPACK_WIX_LICENSE_RTF "${PROJECT_SOURCE_DIR}/misc/copyright.rtf")
  set(CPACK_WIX_EXTRA_SOURCES
     ${CMAKE_BINARY_DIR}/language.wxs
     ${CMAKE_BINARY_DIR}/doc/documentation.wxs
     ${CMAKE_BINARY_DIR}/misc/misc.wxs
     ${CMAKE_BINARY_DIR}/misc/dynamic.wxs
     )
  target_link_options(${CMAKE_PROJECT_NAME} PRIVATE -mwindows -MD)
  install(DIRECTORY
	  ${CMAKE_BINARY_DIR}/platforms
	  ${CMAKE_BINARY_DIR}/sqldrivers
	  ${CMAKE_BINARY_DIR}/styles
	  DESTINATION ${RUNTIME_DEST}
  )
  install(FILES ${CMAKE_BINARY_DIR}/${QT}Core.dll
		${CMAKE_BINARY_DIR}/${QT}Gui.dll
		${CMAKE_BINARY_DIR}/${QT}Help.dll
		${CMAKE_BINARY_DIR}/${QT}Sql.dll
		${CMAKE_BINARY_DIR}/${QT}Widgets.dll
		${CMAKE_BINARY_DIR}/libgcc_s_seh-1.dll
		${CMAKE_BINARY_DIR}/libstdc++-6.dll
		${CMAKE_BINARY_DIR}/libwinpthread-1.dll
		${SYSTEM32}/vcruntime140.dll
		${OPENSSL_ROOT_DIR}/bin/libcrypto-${OPENSSL_LIBRARY_MAJOR}-x64.dll
	  DESTINATION ${RUNTIME_DEST}
  )
  install(CODE "execute_process(COMMAND cmake -E chdir \${CMAKE_INSTALL_PREFIX} tar cvf ${RUNTIME_DEST}.zip --format=zip -- ${RUNTIME_DEST})")
  set(CMAKE_INSTALL_PREFIX ${CMAKE_BINARY_DIR})

else()
  if(CMAKE_INSTALL_PREFIX_INITIALIZED_TO_DEFAULT)
    set(CMAKE_INSTALL_PREFIX /usr/local CACHE PATH
        "Default installation directory" FORCE)
  endif()
  message(STATUS "PREFIX: " ${CMAKE_INSTALL_PREFIX})
  set(CPACK_SOURCE_GENERATOR "TGZ")
  set(CPACK_SOURCE_IGNORE_FILES \\.git/ build/ ".*~$")
  set(CPACK_VERBATIM_VARIABLES YES)
endif()

include(CPack)

=== doc/CMakeLists.txt ===

set(S "${PROJECT_SOURCE_DIR}/doc")
set(D "${PROJECT_BINARY_DIR}/doc")
file(MAKE_DIRECTORY "${D}")

find_program(SPHINX sphinx-build)
find_package(Qt6 QUIET OPTIONAL_COMPONENTS ToolsTools)

set(FILENAMES
	index commandline requests object-ids common-actions database options
	certificates revocationlist changelog introduction privatekey
	step-by-step certificate-input template smartcard miscellaneous
)

foreach(file ${FILENAMES})
  list(APPEND RST_SOURCE "${S}/rst/${file}.rst")
  list(APPEND RST_DEST "${D}/rst/${file}.rst")
  list(APPEND HTML_DEST "${D}/html/${file}.html")
  list(APPEND HTML_FILE "${file}.html")
  list(APPEND QTHELP_DEST "${D}/qthelp/${file}.html")
endforeach()

foreach(doc ${HTML_FILE} xca.qhc xca.qch)
  string(REPLACE "-" "" id ${doc})
  guid(${doc})
  list(APPEND DOC_COMPREFS "  <ComponentRef Id=\"Csphinx.${id}\"/>\n")
  list(APPEND DOC_COMPS "  <Component Id=\"Csphinx.${id}\" Guid=\"${GUID}\">
    <File Id=\"sphinx.${id}\" Source=\"${D}/qthelp/${doc}\" KeyPath=\"yes\"/>
  </Component>\n")
endforeach()

string(APPEND WIX_DOC_CONTENT
"<DirectoryRef Id=\"html\">\n" ${DOC_COMPS} "</DirectoryRef>\n"
"<ComponentGroup Id=\"GroupDocumentation\">\n" ${DOC_COMPREFS} "</ComponentGroup>"
)

WixFile(${D}/documentation.wxs ${WIX_DOC_CONTENT})

if(SPHINX)
  configure_file(${S}/conf.py.in ${D}/rst/conf.py)
  add_custom_command(
	OUTPUT ${HTML_DEST}
	COMMAND ${SPHINX} -q -b html ${D}/rst ${D}/html
	DEPENDS ${D}/rst/conf.py sphinx-src
	COMMENT "Create HTML documentation"
  )
  add_custom_target(sphinx-html DEPENDS ${HTML_DEST})
  add_custom_command(
	OUTPUT ${D}/qthelp/xca.qhcp ${D}/qthelp/xca.qhp ${QTHELP_DEST}
	COMMAND ${SPHINX} -q -b qthelp ${D}/rst ${D}/qthelp
	DEPENDS ${D}/rst/conf.py sphinx-src
	COMMENT "Create context sensitive help"
  )
  add_custom_target(sphinx-qthelp
	DEPENDS ${D}/qthelp/xca.qhcp ${D}/qthelp/xca.qhp ${QTHELP_DEST}
  )
  add_custom_command(
	OUTPUT ${D}/rst/database_schema.sql
	COMMAND ${CMAKE_COMMAND} -E make_directory ${D}/rst/_static
	COMMAND ${CMAKE_COMMAND}
		-D SRC=${PROJECT_SOURCE_DIR}/lib/database_schema.cpp
		-D DST=${D}/rst/database_schema.sql
		-P ${PROJECT_SOURCE_DIR}/cmake/database_schema.cmake
	DEPENDS ${PROJECT_SOURCE_DIR}/lib/database_schema.cpp
	COMMENT "Generating database schema SQL documentation"
  )
  add_custom_command(
	OUTPUT ${D}/rst.stamp
	COMMAND ${CMAKE_COMMAND} -E make_directory ${D}/rst/_static
	COMMAND ${CMAKE_COMMAND} -E copy_if_different
				${PROJECT_SOURCE_DIR}/img/bigcert.png
				${D}/rst/_static
	COMMAND ${CMAKE_COMMAND} -E copy_if_different
				${PROJECT_SOURCE_DIR}/COPYRIGHT
				${PROJECT_SOURCE_DIR}/changelog
				${RST_SOURCE} ${D}/rst
	DEPENDS ${PROJECT_SOURCE_DIR}/COPYRIGHT
		${PROJECT_SOURCE_DIR}/changelog
		${RST_SOURCE}
	COMMENT "Prepare Sphinx source directory"
  )
  add_custom_command(
	OUTPUT ${D}/rst/arguments.rst
	COMMAND xcadoc rst ${D}/rst/arguments.rst
	COMMENT "Generate 'rst' commandline documentation"
  )
  add_dependencies(${CMAKE_PROJECT_NAME} sphinx-html)
  target_sources(${CMAKE_PROJECT_NAME} PRIVATE ${HTML_DEST})
  add_custom_target(sphinx-src
	DEPENDS ${D}/rst.stamp
		${D}/rst/database_schema.sql
		${D}/rst/arguments.rst
  )

  if (UNIX)
    if (APPLE)
      execute_process(COMMAND ln -fs .doc/html/index.html ${D}/manual.html)
      install(FILES ${D}/manual.html DESTINATION .)
      set(HTML_INSTALL_DEST .doc/html)
      install(DIRECTORY ${D}/html DESTINATION .doc PATTERN ".*" EXCLUDE)
    else()
      install(DIRECTORY ${D}/html/ DESTINATION ${CMAKE_INSTALL_DOCDIR}
          PATTERN ".*" EXCLUDE
      )
    endif()
  endif()

  if (QT_VERSION VERSION_LESS 5.12.0)
    if (TARGET ${QT}::qcollectiongenerator)
      set(QHELPGEN $<TARGET_FILE:${QT}::qcollectiongenerator>)
    endif()
  else()
    if(TARGET ${QT}::qhelpgenerator)
      set(QHELPGEN $<TARGET_FILE:${QT}::qhelpgenerator>)
    endif()
  endif()
  if(QHELPGEN)
    set(QTHELP_IDX ${D}/qthelp/xca.qhc ${D}/qthelp/xca.qch)
    add_custom_command(
	OUTPUT ${QTHELP_IDX}
	COMMAND ${QHELPGEN} ${D}/qthelp/xca.qhcp
	DEPENDS sphinx-qthelp
	COMMENT "Create context sensitive help index"
    )
    add_custom_target(sphinx-qtcollgen DEPENDS ${QTHELP_IDX})
    target_sources(${CMAKE_PROJECT_NAME} PRIVATE ${QTHELP_DEST} ${QTHELP_IDX})
    add_dependencies(${CMAKE_PROJECT_NAME} sphinx-qtcollgen)
    list(APPEND APP_RESOURCES ${QTHELP_DEST} ${QTHELP_IDX})

    if (UNIX AND NOT APPLE)
        install(FILES ${QTHELP_DEST} ${QTHELP_IDX}
                DESTINATION ${CMAKE_INSTALL_DATADIR}/${CMAKE_PROJECT_NAME}/html
        )
    elseif (WIN32)
        install(FILES ${QTHELP_DEST} ${QTHELP_IDX}
                DESTINATION ${RUNTIME_DEST}/html
        )
    endif()

  else()
    message(WARNING "Application 'qhelpgenerator' not found. In-app documentation disabed.")
  endif()
else(SPHINX)
  message(WARNING "sphinx-build binary not found. Documentation generation disabled")
endif(SPHINX)

if (NOT WIN32)
  add_custom_command(
	OUTPUT "${D}/xca.1.gz"
	COMMAND cat "${S}/xca.1.head" "${D}/xca.1.options" "${S}/xca.1.tail" | gzip -n9 > "${D}/xca.1.gz"
	DEPENDS "${S}/xca.1.head" "${S}/xca.1.tail"
		"${D}/xca.1.options"
	COMMENT "Compiling man page"
  )
  add_custom_command(
	OUTPUT "${D}/xca.1.options"
	COMMAND xcadoc man "${D}/xca.1.options"
	COMMENT "Generate 'man' commandline documentation"
  )
  add_custom_target(manpage ALL DEPENDS ${D}/xca.1.gz)
  if (NOT APPLE)
    install(FILES "${D}/xca.1.gz"
        DESTINATION ${CMAKE_INSTALL_MANDIR}/man1
    )
  endif()
  add_dependencies(${CMAKE_PROJECT_NAME} manpage)
endif()

=== img/CMakeLists.txt ===

set(S "${PROJECT_SOURCE_DIR}/img")
set(D "${PROJECT_BINARY_DIR}/img")
file(MAKE_DIRECTORY ${D})

macro(Install_PNG size)
  install(FILES ${S}/xca-icons.iconset/icon_${size}.png
	DESTINATION ${ICONDIR}/${size}/apps RENAME xca.png
  )
  install(FILES ${S}/xca-icons.iconset/icon_${size}.png
	DESTINATION ${ICONDIR}/${size}/mimetypes RENAME x-xca-database.png
  )
  install(FILES ${S}/xca-icons.iconset/icon_${size}.png
	DESTINATION ${ICONDIR}/${size}/mimetypes RENAME x-xca-template.png
  )
endmacro()

if(APPLE)

  ###### MAC ICONS
  find_program(ICONUTIL iconutil)
  if(ICONUTIL)
    set(ICONS "${D}/xca-icons.icns")
    file(GLOB ICON_SRC ${S}/xca-icons.iconset/*.png)
    add_custom_command(OUTPUT ${ICONS}
	  COMMAND iconutil --convert icns -o ${ICONS}
		  ${S}/xca-icons.iconset
	  DEPENDS ${ICON_SRC}
    )
    set_source_files_properties(${ICONS} PROPERTIES GENERATED TRUE)
    add_custom_target(mac-icons DEPENDS ${ICONS})
    add_dependencies(${CMAKE_PROJECT_NAME} mac-icons)
    target_sources(${CMAKE_PROJECT_NAME} PRIVATE ${ICONS})
    list(APPEND APP_RESOURCES ${ICONS})
  endif()
  set(CPACK_BUNDLE_ICON ${ICONS})

elseif(WIN32)
    ENABLE_LANGUAGE(RC)
    target_sources(${CMAKE_PROJECT_NAME} PRIVATE ${S}/w32res.rc)
endif()

if (UNIX AND NOT APPLE)

  install(FILES ${S}/xca-32x32.xpm
	DESTINATION ${CMAKE_INSTALL_DATADIR}/pixmaps
  )
  set(ICONDIR ${CMAKE_INSTALL_DATADIR}/icons/hicolor)

  Install_PNG(16x16)
  Install_PNG(32x32)
  Install_PNG(48x48)
  Install_PNG(64x64)

endif()

=== lang/CMakeLists.txt ===

set(S "${PROJECT_SOURCE_DIR}/lang")
set(D "${PROJECT_BINARY_DIR}")

list(APPEND XCA_QT_LANGUAGES de fr ja pl ru tr es it sk bg)
list(APPEND XCA_LANGUAGES id hr nl pt_BR zh_CN fa ${XCA_QT_LANGUAGES})

foreach(lang ${XCA_LANGUAGES})
  guid(${lang})
  list(APPEND TS_FILES ${S}/xca_${lang}.ts)
  list(APPEND LANG_COMPREFS "  <ComponentRef Id=\"Ci18n.${lang}\"/>\n")
  set(LANG_COMPS "  <Component Id=\"Ci18n.${lang}\" Guid=\"${GUID}\">
    <File Id=\"xca_${lang}.qm\" Source=\"${D}/xca_${lang}.qm\" KeyPath=\"yes\"/>\n")
  if(EXISTS ${_qt_bin_dir}/../translations/qt_${lang}.qm)
    list(APPEND QM_FILES ${_qt_bin_dir}/../translations/qt_${lang}.qm)
    string(APPEND LANG_COMPS "    <File Id=\"qt_${lang}.qm\" Source=\"${_qt_bin_dir}/../translations/qt_${lang}.qm\"/>\n")
  endif()
  string(APPEND LANG_COMPS "  </Component>\n")
  list(APPEND LANG_ALLCOMPS ${LANG_COMPS})
endforeach()

string(APPEND WIX_LANG_CONTENT
  "<DirectoryRef Id=\"i18n\">\n" ${LANG_ALLCOMPS} "</DirectoryRef>\n"
  "<ComponentGroup Id=\"GroupI18n\">\n" ${LANG_COMPREFS} "</ComponentGroup>"
)

WixFile(${D}/language.wxs ${WIX_LANG_CONTENT})
if (${QT_VERSION} VERSION_LESS 6.0.0 )
  qt5_add_translation(QM_FILES ${TS_FILES} OPTIONS -silent)
  message(STATUS "Updating translations from source with 'lupdate' only supprted with QT6")
  target_sources(${CMAKE_PROJECT_NAME} PRIVATE ${QM_FILES})
else()
  qt_add_translations(xca TS_FILES ${TS_FILES} ${S}/xca.ts
			  LRELEASE_OPTIONS -silent
			  QM_FILES_OUTPUT_VARIABLE QM_FILES
  )
  add_custom_target(trans DEPENDS xca_lupdate "${S}/xca.pot")
endif()
list(APPEND APP_RESOURCES ${QM_FILES})
target_sources(${CMAKE_PROJECT_NAME} PRIVATE ${QM_FILES})

if (UNIX AND NOT APPLE)
  install(FILES ${QM_FILES}
	DESTINATION ${CMAKE_INSTALL_DATADIR}/${CMAKE_PROJECT_NAME}/i18n
  )
elseif(WIN32)
  install(FILES ${QM_FILES}
	  DESTINATION ${RUNTIME_DEST}/i18n
  )
endif()

find_program(LCONVERT lconvert)
add_custom_command(
	OUTPUT "${S}/xca.pot"
	COMMAND ${LCONVERT} -if ts -of po -i "${S}/xca.ts" -o "${S}/xca.pot"
	DEPENDS "${S}/xca.ts"
	COMMENT "Update POT file"
)

=== lib/CMakeLists.txt ===

list(APPEND xcadoc_sources arguments.cpp arguments.h xcadoc.cpp)

list(APPEND xca_sources
BioByteArray.cpp	dbhistory.cpp		pki_key.cpp
BioByteArray.h		dbhistory.h		pki_key.h
Passwd.cpp		entropy.cpp		pki_lookup.h
Passwd.h		entropy.h		pki_multi.cpp
arguments.cpp		exception.h		pki_multi.h
arguments.h		func.cpp		pki_pkcs12.cpp
asn1int.cpp		func.h			pki_pkcs12.h
asn1int.h		headerlist.h		pki_pkcs7.cpp
asn1time.cpp		ipvalidator.h		pki_pkcs7.h
asn1time.h		load_obj.cpp		pki_scard.cpp
base.h			load_obj.h		pki_scard.h
builtin_curves.cpp	main.cpp		pki_temp.cpp
builtin_curves.h	main.h			pki_temp.h
database_model.cpp	oid.cpp			pki_x509.cpp
database_model.h	oid.h			pki_x509.h
db_base.cpp		opensc-pkcs11.h		pki_x509req.cpp
db_base.h		openssl_compat.h	pki_x509req.h
db_crl.cpp		pass_info.cpp		pki_x509super.cpp
db_crl.h		pass_info.h		pki_x509super.h
db_key.cpp		pk11_attribute.cpp	settings.cpp
db_key.h		pk11_attribute.h	settings.h
db_temp.cpp		pkcs11.cpp		sql.cpp
db_temp.h		pkcs11.h		sql.h
db_token.cpp		pkcs11_lib.cpp		version.cpp
db_token.h		pkcs11_lib.h		x509name.cpp
db_x509.cpp		pki_base.cpp		x509name.h
db_x509.h		pki_base.h		x509rev.cpp
db_x509req.cpp		pki_crl.cpp		x509rev.h
db_x509req.h		pki_crl.h		x509v3ext.cpp
db_x509super.cpp	pki_evp.cpp		x509v3ext.h
db_x509super.h		pki_evp.h		xfile.h
dhgen.cpp		dhgen.h			XcaProgress.cpp
XcaProgress.h		XcaWarningCore.cpp	XcaWarningCore.h
PwDialogCore.cpp	PwDialogCore.h		digest.h
digest.cpp		pki_export.cpp
)

list(TRANSFORM xca_sources PREPEND ${PROJECT_SOURCE_DIR}/lib/)
list(TRANSFORM xcadoc_sources PREPEND ${PROJECT_SOURCE_DIR}/lib/)

list(APPEND xca_sources ${PROJECT_BINARY_DIR}/local.h)
list(APPEND xcadoc_sources ${PROJECT_BINARY_DIR}/local.h)

target_sources(${CMAKE_PROJECT_NAME} PRIVATE ${xca_sources})
target_sources(xcadoc PRIVATE ${xcadoc_sources})

=== misc/CMakeLists.txt ===

set(S "${PROJECT_SOURCE_DIR}/misc")
set(D "${PROJECT_BINARY_DIR}/misc")
file(MAKE_DIRECTORY ${D})

configure_file(${S}/Info.plist.in ${D}/Info.plist)
configure_file(${S}/dynamic.wxs.in ${D}/dynamic.wxs)

set(CPACK_RESOURCE_FILE_LICENSE "${S}/copyright.rtf")
set(CPACK_BUNDLE_PLIST ${D}/Info.plist)
set(CPACK_DMG_DS_STORE ${S}/dmg.DS_Store)

set_property(TARGET ${PROJECT_NAME}
             PROPERTY MACOSX_BUNDLE_INFO_PLIST ${D}/Info.plist)

##### XCA Templates
set(TEMPLATES CA.xca TLS_server.xca TLS_client.xca)
foreach(templ ${TEMPLATES})
  list(APPEND XCA_TEMPLATES ${S}/${templ})
endforeach()
target_sources(${CMAKE_PROJECT_NAME} PRIVATE ${XCA_TEMPLATES})
list(APPEND APP_RESOURCES "${XCA_TEMPLATES}")

##### Text Files ids.txt eku.txt dn.txt

macro(Text_header file)
    add_custom_command(OUTPUT "${D}/${file}.txt"
        COMMAND ${CMAKE_COMMAND} -DFILE=${file} -DSRC="${S}" -DDST="${D}"
        -P "${PROJECT_SOURCE_DIR}/cmake/text_header_file.cmake"
        DEPENDS "${S}/${file}.text" "${S}/preamble.txt"
    )
    list(APPEND TEXT_FILES "${D}/${file}.txt")
endmacro()

Text_header(dn)
Text_header(eku)
Text_header(oids)

foreach(misc_name ${TEXT_FILES} ${XCA_TEMPLATES})
  string(REGEX REPLACE ".*/" "" misc_basename ${misc_name})
  guid(${misc_basename})
  list(APPEND MISC_COMPREFS "  <ComponentRef Id=\"Cmisc.${misc_basename}\"/>\n")
  list(APPEND MISC_COMPS "  <Component Id=\"Cmisc.${misc_basename}\" Guid=\"${GUID}\">
    <File Id=\"misc.${misc_basename}\" Source=\"${misc_name}\" KeyPath=\"yes\"/>
  </Component>\n")
endforeach()

string(APPEND WIX_MISC_CONTENT
"<DirectoryRef Id=\"INSTALLDIR\">\n" ${MISC_COMPS} "</DirectoryRef>
<ComponentGroup Id=\"GroupMisc\">\n" ${MISC_COMPREFS} "</ComponentGroup>")

WixFile(${D}/misc.wxs ${WIX_MISC_CONTENT})

target_sources(${CMAKE_PROJECT_NAME} PRIVATE ${TEXT_FILES})
list(APPEND APP_RESOURCES ${TEXT_FILES})

if (UNIX AND NOT APPLE)
  install(FILES ${TEXT_FILES} ${XCA_TEMPLATES}
        DESTINATION ${CMAKE_INSTALL_DATADIR}/${CMAKE_PROJECT_NAME}
  )
  install(FILES misc/xca.desktop
        DESTINATION ${CMAKE_INSTALL_DATADIR}/applications
  )
  install(FILES misc/xca.completion
        DESTINATION ${CMAKE_INSTALL_DATADIR}/bash-completion/completions
        RENAME xca
  )
  install(FILES misc/xca.xml
        DESTINATION ${CMAKE_INSTALL_DATADIR}/mime/packages
  )
elseif(WIN32)
  install(FILES ${TEXT_FILES} ${XCA_TEMPLATES}
	  DESTINATION ${RUNTIME_DEST}
  )
endif()

=== widgets/CMakeLists.txt ===
list(APPEND xca_sources
CertDetail.cpp		NewCrl.cpp		XcaApplication.h
CertDetail.h		NewCrl.h		XcaDialog.cpp
CertExtend.cpp		NewKey.cpp		XcaDialog.h
CertExtend.h		NewKey.h		XcaHeaderView.cpp
CertTreeView.cpp	NewX509.cpp		XcaHeaderView.h
CertTreeView.h		NewX509.h
CrlDetail.cpp		NewX509_ext.cpp		XcaProxyModel.cpp
CrlDetail.h		OidResolver.cpp		XcaProxyModel.h
CrlTreeView.cpp		OidResolver.h		XcaTreeView.cpp
CrlTreeView.h		OpenDb.cpp		XcaTreeView.h
ExportDialog.cpp	OpenDb.h		XcaWarning.cpp
ExportDialog.h		Options.cpp		XcaWarning.h
FocusCombo.h		Options.h		clicklabel.cpp
Help.cpp		PwDialog.cpp		clicklabel.h
Help.h			PwDialog.h
ImportMulti.cpp		ReqTreeView.cpp
ImportMulti.h		ReqTreeView.h		distname.cpp
ItemCombo.h		RevocationList.cpp	distname.h
KeyDetail.cpp		RevocationList.h	hashBox.cpp
KeyDetail.h		SearchPkcs11.cpp	hashBox.h
KeyTreeView.cpp		SearchPkcs11.h		kvView.cpp
KeyTreeView.h		TempTreeView.cpp	kvView.h
MW_help.cpp		TempTreeView.h		v3ext.cpp
MW_menu.cpp		X509SuperTreeView.cpp	v3ext.h
MainWindow.cpp		X509SuperTreeView.h	validity.cpp
MainWindow.h		XcaApplication.cpp	validity.h
pkcs12EncBox.h
pkcs12EncBox.cpp
)

list(TRANSFORM xca_sources PREPEND ${PROJECT_SOURCE_DIR}/widgets/)
target_sources(${CMAKE_PROJECT_NAME} PRIVATE ${xca_sources})

=== debian/changelog ===
xca (2.5.0-1ubuntu2) noble; urgency=medium

  * No-change rebuild for CVE-2024-3094

 -- William Grant <wgrant@ubuntu.com>  Mon, 01 Apr 2024 19:36:46 +1100

xca (2.5.0-1ubuntu1) noble; urgency=medium

  * Replace libqt5sql5 with libqt5sql5t64 in Build-Depends.

 -- Michael Hudson-Doyle <michael.hudson@ubuntu.com>  Mon, 25 Mar 2024 14:45:02 +1300

xca (2.5.0-1build2) noble; urgency=medium

  * No-change rebuild against libqt5core5t64

 -- Steve Langasek <steve.langasek@ubuntu.com>  Fri, 15 Mar 2024 07:31:41 +0000

xca (2.5.0-1build1) noble; urgency=medium

  * No-change rebuild against libssl3t64

 -- Steve Langasek <steve.langasek@ubuntu.com>  Tue, 05 Mar 2024 02:17:12 +0000

xca (2.5.0-1) unstable; urgency=medium

  * New upstream release (2.5.0)
  * Upstream now uses CMake for builds, which invalidates multiple quilt 
    patches.
  * Dropped patches from d/patches:
    - xca-240-ossl3.patch: Already included in 2.5.0
    - 0001-Remove-misc-Info.plist-in-clean-target.patch: Obsolete due 
      to CMake move.
    - 0002-pkg-config-remove-hardcoding.patch: Obsolete due to
      CMake move.
  * d/control: Update build dependencies because we use CMake; use XCA
    upstream git home for build-dependencies list.
  * d/rules: Numerous changes to adapt for CMake build environment 
    as changed by Upstream.

 -- Thomas Ward <teward@ubuntu.com>  Wed, 11 Oct 2023 14:52:56 -0400

=== debian/control ===
Source: xca
Section: x11
Priority: optional
Maintainer: Thomas Ward <teward@ubuntu.com>
Build-Depends: debhelper-compat (= 12),
               qtbase5-dev,
               qttools5-dev,
               qttools5-dev-tools,
               libssl-dev,
               linuxdoc-tools,
               libltdl-dev,
               pkg-config,
               dpkg-dev (>= 1.16.1~),
               libqt5sql5t64,
               libqt5help5,
               python3-sphinx,
               python3-sphinxcontrib.qthelp,
               cmake
Standards-Version: 4.6.2
Homepage: https://hohnstaedt.de/xca/
Vcs-Browser: https://salsa.debian.org/debian/xca
Vcs-Git: https://salsa.debian.org/debian/xca.git

Package: xca
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends},
 libqt5sql5-sqlite
Recommends: libqt5sql5-mysql, libqt5sql5-psql, libqt5sql5-odbc
Description: x509 Certification Authority management tool based on QT
 XCA creates and manages Certificate authorities and helps the user to
 create and manage keys, certificates, certificate sign requests,
 certificate revocation lists etc.
 .
 All data is saved in an encrypted, portable database, and can be exported
 in various standard formats. XCA is also available for MacOS X and
 Windows systems.
 .
 For a good workflow, certificate templates can be defined to make the
 creation of new certificates an easy task.

=== debian/rules ===
#!/usr/bin/make -f

include /usr/share/dpkg/pkg-info.mk

export DEB_BUILD_MAINT_OPTIONS = hardening=+all
export QT_SELECT=qt5
export CMAKE_INSTALL_PREFIX=/usr

%:
	dh $@

override_dh_auto_configure:
	STRIP=true dh_auto_configure

override_dh_auto_install:
	destdir=$(CURDIR)/debian/xca dh_auto_install

override_dh_auto_build:
	dh_auto_build -- all

ORIG=${DEB_SOURCE}_${DEB_VERSION_UPSTREAM}

get-orig-source:
	git archive --format=tar upstream/${DEB_VERSION_UPSTREAM} --prefix=${ORIG}/ | gzip -9 > ../${ORIG}.orig.tar.gz

## xca 2.6.0

=== CMakeLists.txt ===
--- 
+++ 
@@ -15,14 +15,46 @@
 list(JOIN OS_DATA_LIST " -- " OS_DATA)
 message(STATUS ${OS_DATA})
 
+string(REGEX MATCH  "([0-9]+\.[0-9]+\.[0-9]+)" OSX_SDK_MINIMUM
+	${CMAKE_OSX_DEPLOYMENT_TARGET} ".0.0.0")
+
 include(GNUInstallDirs)
+include(CTest)
 
 ##### Git command to tweak the version and commit hash
 include(cmake/git_version.cmake)
+file(WRITE ${PROJECT_BINARY_DIR}/PKGVERSION.txt ${PROJECT_VERSION}\n)
 
 ##### Build specifications
 
+find_program(CCACHE_EXECUTABLE ccache)
+mark_as_advanced(CCACHE_EXECUTABLE)
+if(CCACHE_EXECUTABLE)
+  if(NOT DEFINED CMAKE_CXX_COMPILER_LAUNCHER AND NOT
+                 CMAKE_CXX_COMPILER MATCHES ".*/ccache")
+    message(STATUS "Enabling ccache")
+    set(CMAKE_CXX_COMPILER_LAUNCHER ${CCACHE_EXECUTABLE} CACHE STRING "")
+  endif()
+endif()
+
 set(ADDRESS_SANITIZER OFF CACHE BOOL "Enable Address sanitizing")
+set(APPSTORE_COMPLIANT OFF CACHE BOOL "Create an Appstore compliant, sanboxed app")
+set(PROVISIONPROFILE "" CACHE STRING "Location of the embedded.provisionprofile")
+if (APPSTORE_COMPLIANT)
+  set(APPLE_DEVELOPER_CERT "3rd Party Mac Developer Application")
+  set(APPSTORE -appstore-compliant)
+else()
+  set(APPLE_DEVELOPER_CERT "Developer ID Application")
+endif()
+if(APPLE)
+  execute_process(COMMAND security find-identity -v
+                  ERROR_QUIET OUTPUT_VARIABLE IDCHECK)
+  string(FIND "${IDCHECK}" "${APPLE_DEVELOPER_CERT}" matchres)
+  if(matchres EQUAL -1)
+    unset(APPLE_DEVELOPER_CERT)
+  endif()
+endif()
+
 set(CMAKE_POSITION_INDEPENDENT_CODE ON)
 
 set(CMAKE_CXX_STANDARD 17)
@@ -34,17 +66,23 @@
 set(CMAKE_AUTOUIC ON)
 add_compile_definitions(OPENSSL_SUPPRESS_DEPRECATED QT_MESSAGELOGCONTEXT)
 
+add_compile_options(-Wall -Wextra -Wno-unknown-pragmas)
 if (ADDRESS_SANITIZER)
   add_compile_options(-fsanitize=address -O1 -fno-omit-frame-pointer -g)
   set(ASAN_LIB -fsanitize=address)
 endif()
+if (CMAKE_CXX_COMPILER_ID MATCHES Clang|GNU)
+  add_compile_options(-fmacro-prefix-map=${PROJECT_SOURCE_DIR}=.)
+endif()
 
 file(GLOB UI_FILES ${CMAKE_AUTOUIC_SEARCH_PATHS}/*.ui)
 
 configure_file(local.h.in local.h)
 
 ##### Libraries and executables
-add_executable(${CMAKE_PROJECT_NAME} img/imgres.qrc ${UI_FILES} ${PROJECT_BINARY_DIR}/local.h)
+add_library(xcalib STATIC)
+add_executable(${CMAKE_PROJECT_NAME} img/imgres.qrc lib/main.cpp
+		${UI_FILES} ${PROJECT_BINARY_DIR}/local.h)
 add_executable(xcadoc ${PROJECT_BINARY_DIR}/local.h)
 
 include_directories(${PROJECT_BINARY_DIR} ${PROJECT_SOURCE_DIR})
@@ -71,6 +109,8 @@
 find_package(QT NAMES ${QTFIXEDVERSION} REQUIRED COMPONENTS Core)
 set(QT Qt${QT_VERSION_MAJOR})
 find_package(${QT} REQUIRED COMPONENTS Core Widgets Sql Help LinguistTools)
+find_package(${QT} QUIET COMPONENTS Test)
+
 message(STATUS "Using ${QT} with version ${QT_VERSION}")
 
 get_target_property(qmake_executable ${QT}::qmake IMPORTED_LOCATION)
@@ -80,16 +120,15 @@
   get_filename_component(OPENSSL_ROOT_DIR ${OPENSSL_INCLUDE_DIR} DIRECTORY)
 endif()
 
-target_link_libraries(${CMAKE_PROJECT_NAME}
+target_link_libraries(xcalib
 	OpenSSL::Crypto
 	${QT}::Widgets ${QT}::Core ${QT}::Sql ${QT}::Help
 	${ASAN_LIB}
 )
 target_link_libraries(xcadoc
-	OpenSSL::Crypto
-	${QT}::Widgets ${QT}::Core ${QT}::Sql ${QT}::Help
-	${ASAN_LIB}
-)
+	OpenSSL::Crypto ${QT}::Core ${ASAN_LIB}
+)
+target_link_libraries(${CMAKE_PROJECT_NAME} ${ASAN_LIB} xcalib)
 
 if (APPLE)
 
@@ -128,15 +167,18 @@
     "\n</Fragment>\n</Wix>")
 endmacro()
 
+add_custom_target(tests)
+
 ##### Sub directories
 
 add_subdirectory(lib)
 add_subdirectory(widgets)
 
+include(lang/CMakeLists.txt)
 include(misc/CMakeLists.txt)
-include(lang/CMakeLists.txt)
 include(doc/CMakeLists.txt)
 include(img/CMakeLists.txt)
+include(test/CMakeLists.txt)
 
 install(TARGETS ${CMAKE_PROJECT_NAME}
 	RESOURCE DESTINATION Resources
@@ -159,16 +201,23 @@
   find_program(MACDEPLOYQT_EXECUTABLE macdeployqt HINTS ${_qt_bin_dir})
   add_custom_command(TARGET ${PROJECT_NAME} POST_BUILD
     COMMAND ${MACDEPLOYQT_EXECUTABLE} $<TARGET_FILE_DIR:${PROJECT_NAME}>/../..
-        -always-overwrite
+        -always-overwrite ${APPSTORE}
     COMMENT "Running macdeployqt..."
   )
-  if (DEFINED ENV{APPLE_DEVELOPER_HASH})
+  if (PROVISIONPROFILE)
     add_custom_command(TARGET ${PROJECT_NAME} POST_BUILD
-      COMMAND codesign --deep --signature-size=96000 --options=runtime --timestamp
-		--entitlements ${PROJECT_SOURCE_DIR}/misc/entitlement.plist
-                --force -s "$ENV{APPLE_DEVELOPER_HASH}"
+      COMMAND cmake -E copy ${PROVISIONPROFILE}
+              $<TARGET_FILE_DIR:${PROJECT_NAME}>/../embedded.provisionprofile)
+  endif()
+  if (DEFINED APPLE_DEVELOPER_CERT)
+    add_custom_command(TARGET ${PROJECT_NAME} POST_BUILD
+      COMMAND codesign --deep --signature-size=96000
+                --options=runtime --timestamp
+		--entitlements ${PROJECT_SOURCE_DIR}/misc/entitlement${APPSTORE}.plist
+		--force -s ${APPLE_DEVELOPER_CERT}
 		$<TARGET_FILE_DIR:${PROJECT_NAME}>/../..
-      COMMENT "Running codesign for $ENV{APPLE_DEVELOPER} ..."
+      COMMENT "Running codesign for ${APPLE_DEVELOPER_CERT} ..."
+      DEPENDS ${PROJECT_SOURCE_DIR}/misc/entitlement${APPSTORE}.plist
     )
   endif()
 
@@ -200,7 +249,7 @@
      ${CMAKE_BINARY_DIR}/doc/documentation.wxs
      ${CMAKE_BINARY_DIR}/misc/misc.wxs
      ${CMAKE_BINARY_DIR}/misc/dynamic.wxs
-     )
+  )
   target_link_options(${CMAKE_PROJECT_NAME} PRIVATE -mwindows -MD)
   install(DIRECTORY
 	  ${CMAKE_BINARY_DIR}/platforms
@@ -220,6 +269,10 @@
 		${OPENSSL_ROOT_DIR}/bin/libcrypto-${OPENSSL_LIBRARY_MAJOR}-x64.dll
 	  DESTINATION ${RUNTIME_DEST}
   )
+  if (OPENSSL_LIBRARY_MAJOR EQUAL 3)
+      install(FILES ${OPENSSL_ROOT_DIR}/lib/ossl-modules/legacy.dll
+	      DESTINATION ${RUNTIME_DEST})
+  endif()
   install(CODE "execute_process(COMMAND cmake -E chdir \${CMAKE_INSTALL_PREFIX} tar cvf ${RUNTIME_DEST}.zip --format=zip -- ${RUNTIME_DEST})")
   set(CMAKE_INSTALL_PREFIX ${CMAKE_BINARY_DIR})

=== img/CMakeLists.txt ===
--- 
+++ 
@@ -5,7 +5,7 @@
 
 macro(Install_PNG size)
   install(FILES ${S}/xca-icons.iconset/icon_${size}.png
-	DESTINATION ${ICONDIR}/${size}/apps RENAME xca.png
+	DESTINATION ${ICONDIR}/${size}/apps RENAME de.hohnstaedt.xca.png
   )
   install(FILES ${S}/xca-icons.iconset/icon_${size}.png
 	DESTINATION ${ICONDIR}/${size}/mimetypes RENAME x-xca-database.png

=== lang/CMakeLists.txt ===
--- 
+++ 
@@ -4,6 +4,7 @@
 
 list(APPEND XCA_QT_LANGUAGES de fr ja pl ru tr es it sk bg)
 list(APPEND XCA_LANGUAGES id hr nl pt_BR zh_CN fa ${XCA_QT_LANGUAGES})
+list(JOIN XCA_LANGUAGES "</string>\n		<string>" LANGUAGES_PLIST)
 
 foreach(lang ${XCA_LANGUAGES})
   guid(${lang})
@@ -30,11 +31,14 @@
   message(STATUS "Updating translations from source with 'lupdate' only supprted with QT6")
   target_sources(${CMAKE_PROJECT_NAME} PRIVATE ${QM_FILES})
 else()
+  get_target_property(LIBSRC xcalib SOURCES)
+  get_target_property(XCASRC xca SOURCES)
   qt_add_translations(xca TS_FILES ${TS_FILES} ${S}/xca.ts
 			  LRELEASE_OPTIONS -silent
 			  QM_FILES_OUTPUT_VARIABLE QM_FILES
+			  SOURCES ${LIBSRC} ${XCASRC}
   )
-  add_custom_target(trans DEPENDS xca_lupdate "${S}/xca.pot")
+  add_custom_target(trans DEPENDS xca_lupdate "${D}/xca.pot")
 endif()
 list(APPEND APP_RESOURCES ${QM_FILES})
 target_sources(${CMAKE_PROJECT_NAME} PRIVATE ${QM_FILES})
@@ -49,10 +53,13 @@
   )
 endif()
 
-find_program(LCONVERT lconvert)
-add_custom_command(
-	OUTPUT "${S}/xca.pot"
-	COMMAND ${LCONVERT} -if ts -of po -i "${S}/xca.ts" -o "${S}/xca.pot"
+find_program(LCONVERT lconvert HINTS ${_qt_bin_dir})
+if (LCONVERT)
+  add_custom_command(
+	OUTPUT "${D}/xca.pot"
+	COMMAND ${LCONVERT} -if ts -of po -i "${S}/xca.ts" -o "${D}/xca.pot"
+	COMMAND ${CMAKE_COMMAND} -E copy "${D}/xca.pot" "${S}/xca.pot"
 	DEPENDS "${S}/xca.ts"
 	COMMENT "Update POT file"
-)
+  )
+endif()

=== lib/CMakeLists.txt ===
--- 
+++ 
@@ -1,7 +1,7 @@
 
 list(APPEND xcadoc_sources arguments.cpp arguments.h xcadoc.cpp)
 
-list(APPEND xca_sources
+list(APPEND xcalib_sources
 BioByteArray.cpp	dbhistory.cpp		pki_key.cpp
 BioByteArray.h		dbhistory.h		pki_key.h
 Passwd.cpp		entropy.cpp		pki_lookup.h
@@ -13,8 +13,8 @@
 asn1time.cpp		ipvalidator.h		pki_pkcs7.h
 asn1time.h		load_obj.cpp		pki_scard.cpp
 base.h			load_obj.h		pki_scard.h
-builtin_curves.cpp	main.cpp		pki_temp.cpp
-builtin_curves.h	main.h			pki_temp.h
+builtin_curves.cpp	pki_temp.cpp
+builtin_curves.h	pki_temp.h
 database_model.cpp	oid.cpp			pki_x509.cpp
 database_model.h	oid.h			pki_x509.h
 db_base.cpp		opensc-pkcs11.h		pki_x509req.cpp
@@ -36,14 +36,39 @@
 dhgen.cpp		dhgen.h			XcaProgress.cpp
 XcaProgress.h		XcaWarningCore.cpp	XcaWarningCore.h
 PwDialogCore.cpp	PwDialogCore.h		digest.h
-digest.cpp		pki_export.cpp
+digest.cpp		pki_export.cpp		debug_info.h
+func_base.cpp		func_base.h		debug_info.cpp
+cmdline.cpp
 )
 
-list(TRANSFORM xca_sources PREPEND ${PROJECT_SOURCE_DIR}/lib/)
-list(TRANSFORM xcadoc_sources PREPEND ${PROJECT_SOURCE_DIR}/lib/)
+macro(ExpandSources target)
+  list(TRANSFORM ${target}_sources PREPEND ${PROJECT_SOURCE_DIR}/lib/)
+  list(APPEND ${target} ${PROJECT_BINARY_DIR}/local.h)
+  target_sources(${target} PRIVATE ${${target}_sources})
+endmacro()
 
-list(APPEND xca_sources ${PROJECT_BINARY_DIR}/local.h)
-list(APPEND xcadoc_sources ${PROJECT_BINARY_DIR}/local.h)
+ExpandSources(xcalib)
+ExpandSources(xcadoc)
 
-target_sources(${CMAKE_PROJECT_NAME} PRIVATE ${xca_sources})
-target_sources(xcadoc PRIVATE ${xcadoc_sources})
+macro(Test name)
+  set(${name}_sources ${ARGN})
+  add_executable(${name} ${name}.cpp)
+  ExpandSources(${name})
+  target_link_libraries(${name} PRIVATE
+    OpenSSL::Crypto ${QT}::Core ${QT}::Test ${QT}::Sql ${ASAN_LIB}
+  )
+  add_test(NAME ${name} COMMAND ${name})
+  set_target_properties(${name} PROPERTIES MACOSX_BUNDLE FALSE)
+  add_dependencies(tests ${name})
+  set_tests_properties(${name} PROPERTIES LABELS "console;lib")
+endmacro()
+
+if(BUILD_TESTING)
+  Test(test_biobytearray BioByteArray.cpp BioByteArray.h)
+  Test(test_asn1int asn1int.cpp asn1int.h func_base.h func_base.cpp)
+  Test(test_asn1time asn1time.cpp asn1time.h func_base.h func_base.cpp)
+  Test(test_entropy entropy.cpp entropy.h func.h func_base.cpp xfile.h)
+  Test(test_x509name x509name.cpp x509name.h func_base.h func_base.cpp
+                                    BioByteArray.h BioByteArray.cpp )
+  Test(test_digest digest.cpp digest.h func_base.cpp func_base.h)
+endif()

=== misc/CMakeLists.txt ===
--- 
+++ 
@@ -68,6 +68,9 @@
   install(FILES misc/xca.xml
         DESTINATION ${CMAKE_INSTALL_DATADIR}/mime/packages
   )
+  install(FILES misc/de.hohnstaedt.xca.metainfo.xml
+        DESTINATION ${CMAKE_INSTALL_DATADIR}/metainfo
+  )
 elseif(WIN32)
   install(FILES ${TEXT_FILES} ${XCA_TEMPLATES}
 	  DESTINATION ${RUNTIME_DEST}

=== test/CMakeLists.txt ===

list(APPEND srcs PwDialogMock.h importPEM.cpp main.cpp main.h
	newKey.cpp pem.cpp export.cpp renewal.cpp)

list(TRANSFORM srcs PREPEND ${PROJECT_SOURCE_DIR}/test/)

add_executable(testxca img/imgres.qrc ${srcs}
		${UI_FILES} ${PROJECT_BINARY_DIR}/local.h)

add_test(NAME testxca COMMAND testxca)
set_tests_properties(testxca PROPERTIES LABELS gui)
add_dependencies(tests testxca)
target_link_libraries(testxca ${ASAN_LIB} ${QT}::Test xcalib)

if (APPLE)
  target_link_libraries(testxca
	${IOKIT_LIBRARY} ${COREFOUNDATION_LIBRARY}
  )
endif()

=== widgets/CMakeLists.txt ===
--- 
+++ 
@@ -25,9 +25,9 @@
 MW_menu.cpp		X509SuperTreeView.cpp	v3ext.h
 MainWindow.cpp		X509SuperTreeView.h	validity.cpp
 MainWindow.h		XcaApplication.cpp	validity.h
-pkcs12EncBox.h
-pkcs12EncBox.cpp
+pkcs12EncBox.h          XcaDetail.h
+pkcs12EncBox.cpp        XcaDetail.cpp
 )
 
 list(TRANSFORM xca_sources PREPEND ${PROJECT_SOURCE_DIR}/widgets/)
-target_sources(${CMAKE_PROJECT_NAME} PRIVATE ${xca_sources})
+target_sources(xcalib PRIVATE ${xca_sources})

=== debian/changelog ===
xca (2.6.0-2) unstable; urgency=medium

  * d/control: Add 'or' dependency on libqt5sql5 for backports compat
  * d/clean: Add additional paths for dh_clean to clean out - some files 
    are generated during build time and not in Makefile clean targets, so
    clean it here. Allows double-builds to work. (Closes: #1045831)
  * d/control: Remove libqt5sql5 dependency as it should be included in 
    libqt5sql5{,t64}. (Closes: #1074383) 

 -- Thomas Ward <teward@ubuntu.com>  Fri, 27 Jun 2024 17:13:00 -0400

xca (2.6.0-1) unstable; urgency=medium

  * New upstream release (2.6.0)
  * d/control: Remove constraints unnecessary since Buster:
    - Build-Depends: Drop versioned constraint on dpkg-dev.
    - Build-Depends: Use pkgconf instead of pkg-config; add pkg-config
      as an "OR"'d dependency for systems without pkgconf (allows for 
      easier backport compat)
  * d/control: Update dependencies affected by t64 migration
    (Closes: #1067697)
  * d/source/git-patches: Remove now-obsolete git-patches. 
  * d/copyright: Update copyright stanzas.

 -- Thomas Ward <teward@ubuntu.com>  Fri, 5 Apr 2024 17:14:00 -0400

=== debian/control ===
--- 
+++ 
@@ -9,9 +9,7 @@
                libssl-dev,
                linuxdoc-tools,
                libltdl-dev,
-               pkg-config,
-               dpkg-dev (>= 1.16.1~),
-               libqt5sql5t64,
+               pkgconf | pkg-config,
                libqt5help5,
                python3-sphinx,
                python3-sphinxcontrib.qthelp,
